import {ScreenEvents} from "./../../../libs/ui-from-dialogue/classes.js";
import {MinecraftEffectTypes} from '@minecraft/server';

const DEBUG_STICK_ENTITY_SHEET = {
	max_pages: 1,
	name: "debug_stick_screen",
	pages: [
	  { type: "modal", page: 1, title: (c)=>{ return `entity.${c.target.typeId.replace("minecraft:","")}.name`;}, elements: [
	       {show: true, name: "mobBattles.name.state", type: "textField", value: (c)=>{ return c.target.nameTag;}, placeHolder: (c)=>{ return (c.target.nameTag||"mobBattles.name.placeholderText");}, action: (c)=>{  c.target.nameTag = c.value||c.target.nameTag; } },
	       { show: true, name: "mobBattles.runCommand.name", type: "textField", value: "", placeHolder: "mobBattles.runCommand.placeholderText", action: (c)=>{ c.target.runCommandAsync(c.value); } },
	       {show: true, name: "mobBattles.addEffect.name", type: "dropdown", value: 0, collection: (c)=>{ let effects = Object.keys(MinecraftEffectTypes); return effects.map((i)=>"potion."+i);}, action: (c)=>{c.target.addEffect(Object.values(MinecraftEffectTypes)[c.value],60); } },
	       
	       { show: (c)=>{ return c.target.hasComponent("minecraft:health"); }, name: "HP", type: "slider", step: 1, min: 0, max: (c)=>{ return c.target.getComponent("minecraft:health").value;}, value: (c)=>{ return c.target.getComponent("minecraft:health").current;}, action: (c)=>{ c.target.getComponent("minecraft:health").setCurrent(c.value); } },
	       { show: (c)=>{ return c.target.hasComponent("minecraft:movement"); }, name: "mobBattles.movementComponent.name", type: "textField", value: (c)=>{ return c.target.getComponent("minecraft:movement").current.toString();}, placeHolder: (c)=>{ return c.target.getComponent("minecraft:movement").current.toString();}, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:movement").current : c.value; c.target.getComponent("minecraft:movement").setCurrent(c.value); } },
	       { show: (c)=>{ return c.target.hasComponent("minecraft:scale"); }, name: "mobBattles.scaleComponent.name", type: "textField", value: (c)=>{ return c.target.getComponent("minecraft:scale").value.toString();}, placeHolder: (c)=>{ return c.target.getComponent("minecraft:scale").value.toString();}, min: -1, max: 5, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:scale").value : c.value; c.target.getComponent("minecraft:scale").value = Math.max(c.element.min,Math.min(c.element.max,c.value)); } },
	       { show: (c)=>{ return c.target.hasComponent("minecraft:skin_id"); }, name: "mobBattles.skinIdComponent.name", type: "textField", value: (c)=>{ return c.target.getComponent("minecraft:skin_id").value.toString();}, min: -2147483648, max: 2147483647, placeHolder: (c)=>{ return c.target.getComponent("minecraft:skin_id").value.toString();}, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:skin_id").value : c.value; c.target.getComponent("minecraft:skin_id").value = Math.max(c.element.min,Math.min(c.element.max,c.value)); } },
	       { show: (c)=>{ return c.target.hasComponent("minecraft:mark_variant"); }, name: "mobBattles.markVariantComponent.name", type: "textField", value: (c)=>{ return c.target.getComponent("minecraft:mark_variant").value.toString();}, placeHolder: (c)=>{ return c.target.getComponent("minecraft:mark_variant").value.toString();}, min: -2147483648, max: 2147483647, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:mark_variant").value : c.value; c.target.getComponent("minecraft:mark_variant").value = Math.min(c.element.max,Math.max(c.element.min,c.value)); } },
	       { show: (c)=>{ return c.target.hasComponent("minecraft:push_through"); }, name: "mobBattles.pushThroughComponent.name", type: "textField", value: (c)=>{ return c.target.getComponent("minecraft:push_through").value.toString();}, placeHolder: (c)=>{ return c.target.getComponent("minecraft:push_through").value.toString();}, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:push_through").value : c.value; c.target.getComponent("minecraft:push_through").value = c.value; } },
	       { show: (c)=>{ return c.target.hasComponent("minecraft:ground_offset"); }, name: "mobBattles.groundOffsetComponent.name", type: "textField", value: (c)=>{ return c.target.getComponent("minecraft:ground_offset").value.toString();}, placeHolder: (c)=>{ return c.target.getComponent("minecraft:ground_offset").value.toString();}, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:ground_offset").value : c.value; c.target.getComponent("minecraft:ground_offset").value = c.value; } },
	       { show: (c)=>{ return c.target.hasComponent("minecraft:friction_modifier"); }, name: "mobBattles.frictionModifierComponent.name", type: "textField", value: (c)=>{ return c.target.getComponent("minecraft:friction_modifier").value.toString();}, placeHolder: (c)=>{ return c.target.getComponent("minecraft:friction_modifier").value.toString();}, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:friction_modifier").value : c.value; c.target.getComponent("minecraft:friction_modifier").value = c.value; } },
           { show: (c)=>{ return c.target.hasComponent("minecraft:breathable"); }, name: "mobBattles.breathableComponent.name", min: -32768, max: 32767, type: "textField", value: (c)=>{ return c.target.getComponent("minecraft:breathable").totalSupply.toString();}, placeHolder: (c)=>{ return c.target.getComponent("minecraft:breathable").totalSupply.toString();}, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:breathable").totalSupply : c.value; c.target.getComponent("minecraft:breathable").setAirSupply( Math.max(c.element.min,Math.min(c.element.max,c.value)) ); }},
           { show: (c)=>{ return c.target.hasComponent("minecraft:color"); }, name: "mobBattles.ColorComponent.name", type: "dropdown", value: (c)=>{ return c.target.getComponent("minecraft:color").value;}, collection: (c)=>{ let colors = []; colors.length = 16; colors.fill("color."); return colors.map((color,index)=>color+index+".name"); }, action: (c)=>{ c.value = Number(c.value); c.value = (isNaN(c.value)) ? c.target.getComponent("minecraft:color").value : c.value; c.target.getComponent("minecraft:color").value = c.value; }}
         ]
      }
	]
};
export const DEBUG_STICK_ENTITY_SCREEN_EVENT = ScreenEvents.entityHit(({entity,hitEntity})=>{
	let res ={player: undefined, target: undefined};
	
	let item = entity?.getComponent("minecraft:inventory")?.container?.getItem(entity?.selectedSlot??0);
	if(entity?.typeId=="minecraft:player"&&(hitEntity!== undefined)&&(item?.typeId=="add:debug_stick_entity")) res.player=entity; res.target=hitEntity;
	return res;
},DEBUG_STICK_ENTITY_SHEET); 