import {ScreenEvents} from "./../../../libs/ui-from-dialogue/classes.js";
import {getSlotInfo} from "./../../utils.js";
import {Vector} from "@minecraft/server";
const EQUIPMENT_EDITOR_SHEET = {
	max_pages: 6,
	name: "equipment_editor_stick",
	pages: [
	  {
		type: "action", page: 0, title: ({target})=>{ return `entity.${target.typeId.replace("minecraft:","")}.name`; }, body: "equipment_editor_stick.body", elements: [
		  { show: true, name: "equipment_editor_stick.page0.headSlot", action: null, icon: "textures/ui/empty_armor_slot_helmet", to: 1 }, /* Head slot */
		  { show: true, name: "equipment_editor_stick.page0.chestSlot", action: null, icon: "textures/ui/empty_armor_slot_chestplate", to: 2 }, /* Chest slot */
		  { show: true, name: "equipment_editor_stick.page0.legsSlot", action: null, icon: "textures/ui/empty_armor_slot_leggings", to: 3  }, /* Legs slot */
		  { show: true, name: "equipment_editor_stick.page0.bootsSlot", action: null, icon: "textures/ui/empty_armor_slot_boots", to: 4 }, /* Boots slot */
		  { show: true, name: "equipment_editor_stick.page0.offhandSlot", action: null, icon: "textures/ui/empty_armor_slot_shield", to: 5 }, /* Offhand slot */
		  { show: true, name: "equipment_editor_stick.page0.mainhandSlot", action: null, icon: "textures/mainhand_element", to: 6 } /* Mainhand slot */
        ]
	  },
	     /* Head Slot page*/
	  {
		type: "action", page: 1, title: "equipmentSlot.head", body: "", elements: [
		  { show: true, name: "equipment_editor_stick.element.deleteItem", action: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", slotType: true } ); data.slotType.setItem(undefined); }, icon: null, to: 0 },
		  { show: ({target})=>{ return !getSlotInfo(target,{ containerType: "equipment", equipmentType: "head", empty: true }).empty; }, name: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", nameTag: true, typeId: true } ); return { rawtext:[{translate: "equipment_editor_stick.element.takeItem", with: [`${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}`] }]}; }, action: ({player,target})=>{ try {let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let container = player.getComponent("minecraft:inventory").container; player.dimension.spawnItem(data1.itemStack,player.location); data1.slotType.setItem(undefined);}catch(error){console.warn(error);}  }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 0, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 0, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 0, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 1, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 1, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 1, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 2, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 2, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 2, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 3, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 3, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 3, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 4, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 4, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 4, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 5, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 5, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 5, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 6, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 6, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 6, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 7, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 7, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 7, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 8, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 8, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 8, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 9, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 9, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 9, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 10, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 10, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 10, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 11, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 11, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 11, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 12, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 12, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 12, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 13, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 13, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 13, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 14, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 14, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 14, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 15, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 15, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 15, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 16, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 16, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 16, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 17, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 17, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 17, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 18, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 18, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 18, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 19, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 19, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 19, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 20, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 20, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 20, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 21, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 21, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 21, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 22, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 22, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 22, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 23, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 23, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 23, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 24, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 24, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 24, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 25, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 25, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 25, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 26, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 26, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 26, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 27, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 27, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 27, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 28, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 28, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 28, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 29, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 29, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 29, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 30, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 30, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 30, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 31, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 31, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 31, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 32, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 32, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 32, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 33, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 33, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 33, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 34, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 34, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 34, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 35, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 35, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 35, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0}
		]
	  },
	    /*Chestplate slot */
	  {
		type: "action", page: 2, title: "equipmentSlot.chest", body: "", elements: [
		  { show: true, name: "equipment_editor_stick.element.deleteItem", action: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", slotType: true } ); data.slotType.setItem(undefined); }, icon: null, to: 0 },
		  { show: ({target})=>{ return !getSlotInfo(target,{ containerType: "equipment", equipmentType: "chest", empty: true }).empty; }, name: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", nameTag: true, typeId: true } ); return { rawtext:[{translate: "equipment_editor_stick.element.takeItem", with: [`${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}`] }]}; }, action: ({player,target})=>{ try {let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "head", itemStack: true, slotType: true } ); let container = player.getComponent("minecraft:inventory").container; player.dimension.spawnItem(data1.itemStack,player.location); data1.slotType.setItem(undefined);}catch(error){console.warn(error);}  }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 0, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 0, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 0, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 1, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 1, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 1, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 2, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 2, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 2, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 3, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 3, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 3, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 4, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 4, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 4, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 5, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 5, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 5, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 6, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 6, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 6, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 7, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 7, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 7, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 8, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 8, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 8, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 9, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 9, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 9, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 10, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 10, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 10, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 11, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 11, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 11, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 12, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 12, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 12, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 13, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 13, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 13, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 14, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 14, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 14, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 15, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 15, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 15, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 16, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 16, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 16, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 17, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 17, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 17, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 18, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 18, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 18, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 19, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 19, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 19, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 20, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 20, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 20, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 21, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 21, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 21, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 22, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 22, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 22, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 23, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 23, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 23, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 24, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 24, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 24, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 25, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 25, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 25, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 26, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 26, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 26, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 27, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 27, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 27, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 28, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 28, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 28, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 29, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 29, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 29, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 30, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 30, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 30, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 31, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 31, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 31, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 32, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 32, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 32, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 33, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 33, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 33, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 34, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 34, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 34, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 35, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 35, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "chest", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 35, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0}
		]
	  },
	  {
		type: "action", page: 3, title: "equipmentSlot.legs", body: "", elements: [
		  { show: true, name: "equipment_editor_stick.element.deleteItem", action: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", slotType: true } ); data.slotType.setItem(undefined); }, icon: null, to: 0 },
		  { show: ({target})=>{ return !getSlotInfo(target,{ containerType: "equipment", equipmentType: "legs", empty: true }).empty; }, name: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", nameTag: true, typeId: true } ); return { rawtext:[{translate: "equipment_editor_stick.element.takeItem", with: [`${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}`] }]}; }, action: ({player,target})=>{ try {let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let container = player.getComponent("minecraft:inventory").container; player.dimension.spawnItem(data1.itemStack,player.location); data1.slotType.setItem(undefined);}catch(error){console.warn(error);}  }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 0, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 0, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 0, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 1, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 1, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 1, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 2, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 2, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 2, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 3, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 3, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 3, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 4, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 4, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 4, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 5, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 5, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 5, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 6, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 6, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 6, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 7, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 7, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 7, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 8, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 8, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 8, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 9, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 9, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 9, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 10, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 10, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 10, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 11, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 11, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 11, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 12, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 12, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 12, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 13, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 13, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 13, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 14, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 14, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 14, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 15, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 15, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 15, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 16, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 16, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 16, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 17, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 17, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 17, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 18, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 18, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 18, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 19, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 19, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 19, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 20, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 20, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 20, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 21, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 21, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 21, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 22, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 22, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 22, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 23, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 23, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 23, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 24, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 24, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 24, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 25, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 25, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 25, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 26, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 26, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 26, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 27, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 27, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 27, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 28, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 28, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 28, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 29, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 29, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 29, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 30, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 30, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 30, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 31, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 31, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 31, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 32, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 32, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 32, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 33, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 33, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 33, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 34, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 34, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 34, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 35, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 35, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "legs", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 35, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0}
		]
	  },
	  /* Feet slot */
	  {
		type: "action", page: 4, title: "equipmentSlot.feet", body: "", elements: [
		  { show: true, name: "equipment_editor_stick.element.deleteItem", action: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", slotType: true } ); data.slotType.setItem(undefined); }, icon: null, to: 0 },
		  { show: ({target})=>{ return !getSlotInfo(target,{ containerType: "equipment", equipmentType: "feet", empty: true }).empty; }, name: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", nameTag: true, typeId: true } ); return { rawtext:[{translate: "equipment_editor_stick.element.takeItem", with: [`${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}`] }]}; }, action: ({player,target})=>{ try {let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let container = player.getComponent("minecraft:inventory").container; player.dimension.spawnItem(data1.itemStack,player.location); data1.slotType.setItem(undefined);}catch(error){console.warn(error);}  }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 0, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 0, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 0, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 1, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 1, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 1, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 2, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 2, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 2, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 3, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 3, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 3, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 4, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 4, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 4, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 5, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 5, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 5, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 6, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 6, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 6, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 7, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 7, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 7, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 8, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 8, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 8, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 9, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 9, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 9, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 10, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 10, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 10, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 11, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 11, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 11, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 12, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 12, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 12, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 13, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 13, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 13, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 14, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 14, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 14, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 15, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 15, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 15, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 16, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 16, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 16, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 17, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 17, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 17, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 18, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 18, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 18, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 19, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 19, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 19, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 20, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 20, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 20, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 21, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 21, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 21, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 22, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 22, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 22, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 23, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 23, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 23, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 24, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 24, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 24, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 25, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 25, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 25, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 26, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 26, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 26, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 27, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 27, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 27, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 28, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 28, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 28, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 29, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 29, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 29, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 30, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 30, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 30, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 31, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 31, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 31, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 32, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 32, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 32, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 33, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 33, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 33, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 34, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 34, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 34, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 35, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 35, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "feet", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 35, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0}
		]
	  },
	    /*Offhand slot*/
	  {
		type: "action", page: 5, title: "equipmentSlot.offhand", body: "", elements: [
		  { show: true, name: "equipment_editor_stick.element.deleteItem", action: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", slotType: true } ); data.slotType.setItem(undefined); }, icon: null, to: 0 },
		  { show: ({target})=>{ return !getSlotInfo(target,{ containerType: "equipment", equipmentType: "offhand", empty: true }).empty; }, name: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", nameTag: true, typeId: true } ); return { rawtext:[{translate: "equipment_editor_stick.element.takeItem", with: [`${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}`] }]}; }, action: ({player,target})=>{ try {let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let container = player.getComponent("minecraft:inventory").container; player.dimension.spawnItem(data1.itemStack,player.location); data1.slotType.setItem(undefined);}catch(error){console.warn(error);}  }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 0, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 0, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 0, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 1, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 1, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 1, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 2, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 2, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 2, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 3, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 3, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 3, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 4, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 4, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 4, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 5, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 5, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 5, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 6, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 6, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 6, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 7, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 7, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 7, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 8, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 8, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 8, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 9, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 9, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 9, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 10, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 10, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 10, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 11, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 11, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 11, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 12, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 12, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 12, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 13, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 13, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 13, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 14, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 14, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 14, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 15, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 15, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 15, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 16, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 16, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 16, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 17, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 17, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 17, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 18, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 18, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 18, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 19, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 19, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 19, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 20, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 20, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 20, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 21, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 21, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 21, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 22, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 22, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 22, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 23, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 23, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 23, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 24, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 24, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 24, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 25, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 25, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 25, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 26, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 26, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 26, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 27, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 27, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 27, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 28, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 28, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 28, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 29, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 29, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 29, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 30, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 30, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 30, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 31, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 31, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 31, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 32, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 32, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 32, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 33, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 33, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 33, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 34, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 34, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 34, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 35, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 35, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "offhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 35, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0}
		]
	  },
	  {
		type: "action", page: 6, title: "equipmentSlot.mainhand", body: "", elements: [
		  { show: true, name: "equipment_editor_stick.element.deleteItem", action: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", slotType: true } ); data.slotType.setItem(undefined); }, icon: null, to: 0 },
		  { show: ({target})=>{ return !getSlotInfo(target,{ containerType: "equipment", equipmentType: "mainhand", empty: true }).empty; }, name: ({target})=>{ let data = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", nameTag: true, typeId: true } ); return { rawtext:[{translate: "equipment_editor_stick.element.takeItem", with: [`${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}`] }]}; }, action: ({player,target})=>{ try {let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let container = player.getComponent("minecraft:inventory").container; player.dimension.spawnItem(data1.itemStack,player.location); data1.slotType.setItem(undefined);}catch(error){console.warn(error);}  }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 0, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 0, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 0, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 1, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 1, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 1, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 2, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 2, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 2, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 3, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 3, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 3, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 4, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 4, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 4, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 5, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 5, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 5, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 6, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 6, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 6, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 7, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 7, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 7, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 8, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 8, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 8, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 9, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 9, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 9, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 10, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 10, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 10, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 11, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 11, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 11, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 12, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 12, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 12, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 13, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 13, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 13, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 14, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 14, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 14, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 15, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 15, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 15, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 16, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 16, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 16, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 17, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 17, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 17, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 18, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 18, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 18, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 19, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 19, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 19, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 20, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 20, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 20, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 21, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 21, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 21, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 22, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 22, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 22, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 23, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 23, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 23, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 24, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 24, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 24, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 25, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 25, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 25, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 26, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 26, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 26, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 27, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 27, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 27, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 28, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 28, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 28, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 29, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 29, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 29, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 30, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 30, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 30, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 31, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 31, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 31, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 32, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 32, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 32, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 33, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 33, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 33, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 34, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 34, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 34, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0},
		  { show: ({player})=>{ return !getSlotInfo(player,{ containerType: "container", slot: 35, empty: true }).empty; }, name: ({player})=>{ let data = getSlotInfo(player, { containerType: "container", slot: 35, amount: true, nameTag: true, typeId: true } ); return {rawtext:[ {translate: `${data.nameTag??('item.' + data.typeId.replace('minecraft:','') + '.name')}` }, {text: ` - ${data.amount??1}` }  ]}; }, action: ({player,target})=>{ let data1 = getSlotInfo(target, { containerType: "equipment", equipmentType: "mainhand", itemStack: true, slotType: true } ); let data2 = getSlotInfo(player, { containerType: "container", slot: 35, itemStack: true, slotType: true } ); data1.slotType.setItem(data2.itemStack); data2.slotType.setItem(data1.itemStack); }, icon: null, to: 0}
		]
	  }
	]
};

export const EQUIPMENT_EDITOR_SCREEN_EVENT = ScreenEvents.entityHit(({entity,hitEntity})=>{
	let res ={player: undefined, target: undefined};
	
	let item = entity?.getComponent("minecraft:inventory")?.container?.getItem(entity?.selectedSlot??0);
	if(entity?.typeId=="minecraft:player"&&(hitEntity!== undefined)&&(item?.typeId=="add:equipment_editor")) res.player=entity; res.target=hitEntity;
	return res;
},EQUIPMENT_EDITOR_SHEET); 